﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace _20AlgCalkowanieNumeryczne
{
    public partial class Form1 : Form
    {
        float f(float x)
        {
            //obliczenia dla funkcji
            //zadanej wzorem f(x)=x^2-36
            //gdyby byla liczona wartość całki
            //to pomiń wartość bezwzględną
            return Math.Abs(x * x - 36);
            //całka x^3/3-36
        }

        float mProstokatow(float a,float b,int n)
        {
            //wszystki eprostokąty mozna zastapić jednym o sumie wysokości każdego
            //i podstawie pojedynczego, pole takiego prostokata bedzie polem całki
            float dx = (b - a) / (float)n,//oblicz podstawe prostokatów
                  h = 0,//bieżąca wysokosci
                  sr = a + (b - a) / (2.0f * n);//srodek pierwszego prostokata
            for(int i = 0; i < n; i++)
            {
                h = h + f(sr);//zwieksz wysokość
                sr = sr + dx;//wzynacz kolejny srodek
            }
            return h*dx;   
        }

        float mTrapez(float a, float b, int n)
        {
            float dx =(b-a)/(float)n,//bieżąca podstawa trapezow
                  da = f(a),//biezacy bok a
                  db,//biezacy bok b
                  h=0;//biezaca wysokosc
            for(int i = 1; i <= n; i++)
            {
                //licz biezacy bok b trapezu
                db = f(a + dx * i);
                h = h + (db + da);
                //ustal nowy bok a
                da = db;
            }
            return h * 0.5f*dx;
        }
        public Form1()
        {
            InitializeComponent();
        }

        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            //wyskocz na BackSpcae, Enter lub minus
            if (e.KeyChar == 8 || e.KeyChar == 13 || e.KeyChar == '-') return;
            if (e.KeyChar < '0' || e.KeyChar > '9') e.Handled = true;//blokuj nienumeryczne
        }

        private void textBox3_KeyPress(object sender, KeyPressEventArgs e)
        {
            //wyskocz na BackSpcae, Enter lub minus
            if (e.KeyChar == 8) return;
            if (e.KeyChar < '0' || e.KeyChar > '9') e.Handled = true;//blokuj nienumeryczne
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (textBox1.Text.Length < 1
                || textBox2.Text.Length < 1
                || textBox3.Text.Length < 1) return;
            float a = float.Parse(textBox1.Text),
                  b = float.Parse(textBox2.Text);
            int n = int.Parse(textBox3.Text);
            MessageBox.Show(
                        mProstokatow(a,b,n).ToString(),
                        "Wartość pola (met. prostokątów):",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Information
                        );
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (textBox1.Text.Length < 1
                            || textBox2.Text.Length < 1
                            || textBox3.Text.Length < 1) return;
            float a = float.Parse(textBox1.Text),
                  b = float.Parse(textBox2.Text);
            int n = int.Parse(textBox3.Text);
            MessageBox.Show(
                            mTrapez(a, b, n).ToString(),
                            "Wartośc pola (met. trapezow):",
                            MessageBoxButtons.OK,
                            MessageBoxIcon.Information
                            );
        }
    }
}
